\  Sokoban by CryptoManceR, Moscow, Russia, Jan-02Feb2k2 
\  Written while learning Forth 
\  Public domain 

\ include dialog.frt

( bytes to allot -- ) ( like allot but clears alloted array )
: zallot here swap dup allot CodeSegment swap 0 Mfill ;
: var variable ;
: (max) if drop else press then ;
: max 2dup > (max) ;
: min 2dup < (max) ;
: >|< rot min max ;

: == 1 pick = ;
: on true swap ! ; ( boolean var -- )
: off false swap ! ; ( boolean var -- )

$ B800 constant scr
49 constant maxlv
var x
var y
var lvl
var lptr
var fptr
var dx
var dy
var consmode

create field 400 zallot

0 constant outer
1 constant empty
2 constant place
3 constant bomb
4 constant sitted
5 constant wall

outer  constant ~
empty  constant _
place  constant p
sitted constant s
bomb   constant b
wall   constant w

: 8pack 8 * + ;
: lvpack 80 0 do 4 0 do 8pack loop , loop c, c, ;

create levels
include levels.frt
\ include 1lv.frt

: xy^ 1- 20 * swap 1- + field + ;  ( x y -- offset in field )
: xy xy^ C@ ;                      ( x y -- value from field )
: xy! xy^ C! ;                     ( val x y -- , val sent to field )

: show  ( -- )
  21 1 do 21 1 do
    i j 2dup 2dup xy -rot x @ y @ d= 5 * -
    A"   _oO#@@" + c@ 
    -rot 80 * + 30 + 2 * scr AC! 
  loop loop
;

: lvload
  80 0 do
    levels lvl @ 162 * i 2 * + + @ \ packed 5 cells
    dup 7 and
   5 0 do
     400 j 5 * 5 i - + - field + c!
     8 / dup 7 and
   loop
   2drop
  loop
  levels lvl @ 162 * + 161 + dup c@ x ! 1- c@ y !
;

: bkey key dup 0 = if drop key 256 + then ; ( -- keycode, +256 if special )

: @+ @ swap @ + ; ( var1 var2 -- var2+var1 )
: dxy^ x dx @+ y dy @+ xy^ ; ( -- field [x+dx,y+dy] )
: 2dxy^ x dx @+ dx @ + y dy @+ dy @ + xy^ ; ( -- field [x+2*dx,y+2*dy] )

: manmv
  dx x @+ x !
  dy y @+ y !
;

: bombmv
  dxy^ dup c@ 2 - swap c!
  2dxy^ dup c@ 2 + swap c!
;

: rulez
  dxy^ c@ dup
  wall = if drop exit then
  bomb < if manmv exit then
  2dxy^ c@ bomb < if bombmv manmv then
;

: ?win true 400 0 do field i + c@ place = if drop false leave then loop ;
     
: dxy! dy ! dx ! ;
: lvset 0 maxlv >|< lvl ! lvload ;

: gamestep
   show
   0 0 dxy!
   bkey
     328 ( up ) == if 0 -1 dxy! then
     333 ( right ) == if 1 0 dxy! then
     336 ( down )  == if 0 1 dxy! then
     331 ( left )  == if -1 0 dxy! then
     43 == if lvl @ 1+ lvset then
     45 == if lvl @ 1- lvset then
     32 == if lvload then
     27 == if bye then
     96 == if consmode on then
    rulez
    ?win if lvl 1+! lvload then
    dropall
;

: cls 2000 0 do $ 0700 i 2* scr a! loop ;

: ` consmode off cls ;

: ConsStep
      ." \r\n>"
      129 78 Expect
      Span @
      If
         Cr
         Span @ 128 c!
         128 Load
         State @
         IfNot
            beep
         Then
      Then
;

: mainloop
 begin
  consmode @ 
  if ConsStep else gamestep then
 again
;

: init   
  consmode off cls
  mainloop
;

: FORTHERR
   ErrNo @ True =
   IfNot
      Base @ >r Decimal
      ." Error #" ErrNo @ . ."    "
      r> Base !
      ?Messages
      If
         ErrNo @ ErrorMessage .ASCIIz
      Then
   Then
   0 State !
   DropAll
   RDropAll
   mainloop
;

' ForthErr ErrorProc !

consmode off
0 lvl ! lvload

Restart init
Save soko-txt.com

: nocons cls begin gamestep again ;
messages off debug on
' bye errorproc !
build soko-t.com
