\  Sokoban by CryptoManceR, Moscow, Russia, Jan-02Feb2k2 
\  Written while learning Forth 
\  Public domain 

use ..\256color.frl
use set_vm.frl
include hlp.frt

( bytes to allot -- ) ( like allot but clears alloted array )
\ : zallot here swap dup allot CodeSegment swap 0 Mfill ;
: (max) if drop else press then ;
: max 2dup > (max) ;
: min 2dup < (max) ;
: >|< rot min max ;
: == 1 pick = ;
: on true swap ! ; ( boolean variable -- )
: off false swap ! ; ( boolean variable -- )
: @@ @ swap @ swap ; ( adr1 adr2 -- val1 val2 )
: @+ @@ + ; ( var1 var2 -- var2+var1 )

49 constant maxlv
variable x
variable y
variable lvl
variable dx
variable dy
variable consmode

create field 400 allot

0 constant outer
1 constant empty
2 constant place
3 constant bomb
4 constant sitted
5 constant wall

include sprites.frt

outer  constant ~
empty  constant _
place  constant p
sitted constant s
bomb   constant b
wall   constant w
~ _ p s b w dropall

: lvpack 80 0 do 4 0 do 8 * + loop , loop c, c, ;

create levels
include levels.frt

: $putspr ( x y SourceSpriteOffset -- )
  CodeSegment 0 0 $SCREEN 7 pick 1- 15 * 7 + 7 pick 1- 9 * 5 + 15 320 15 9 $copy256
  2drop
;

: ico [ 9 15 * ] Literal * s_lvl + $putspr ; ( x y SpriteNum -- )

: xy^ 1- 20 * swap 1- + field + ;  ( x y -- offset in field )
: xy xy^ C@ ;                      ( x y -- value from field )
: xy! xy^ C! ;                     ( val x y -- , val sent to field )

: show  ( -- )
  21 1 do 21 1 do
     i j 2dup xy ico
  loop loop
  x @ y @ s_man $putspr
;

: lvload
  80 0 do
    levels lvl @ 162 * i 2 * + + @ \ packed 5 cells
    dup 7 and
   5 0 do
     400 j 5 * 5 i - + - field + c!
     8 / dup 7 and
   loop
   2drop
  loop
  levels lvl @ 162 * + 161 + dup c@ x ! 1- c@ y !
;

: bye 3 setvm ttl bye ;

: bkey key dup 0 = if drop key 256 + then ; ( -- keycode, +256 if special )

: dxy^ x dx @+ y dy @+ xy^ ; ( -- field [x+dx,y+dy] )
\ : 2dxy^ x dx @+ dx @ + y dy @+ dy @ + xy^ ; ( -- field [x+2*dx,y+2*dy] )
: 2dxy^ x dx @@ 2* + y dy @@ 2* + xy^ ; ( -- field [x+2*dx,y+2*dy] )

: manmv
  dx x @+ x !
  dy y @+ y !
;

: bombmv
  dxy^ dup c@ 2 - swap c!
  2dxy^ dup c@ 2 + swap c!
;

: rulez
  dxy^ c@ dup
  wall = if drop exit then
  bomb < if manmv exit then
  2dxy^ c@ bomb < if bombmv manmv then
;

: ?win true 400 0 do field i + c@ place = if drop false leave then loop ;
     
: dxy! dy ! dx ! ;
: lvset 0 maxlv >|< lvl ! lvload ;

: gamestep
   show
   0 0 dxy!
   bkey
     328 ( up ) == if 0 -1 dxy! then
     333 ( right ) == if 1 0 dxy! then
     336 ( down )  == if 0 1 dxy! then
     331 ( left )  == if -1 0 dxy! then
     315 ( F1 )  == if hlp then
     43 == if lvl @ 1+ lvset then
     45 == if lvl @ 1- lvset then
     32 == if lvload then
     27 == if bye then
     96 == if consmode on then
    rulez
    ?win if lvl 1+! lvload then
    dropall
;

: ` consmode off 19 setvm ;

: ConsStep
      ." \r\n>"
      129 78 Expect
      Span @
      If
         Cr
         Span @ 128 c!
         128 Load
         State @
         IfNot
            beep
         Then
      Then
;

: mainloop
 begin
  consmode @ 
  if ConsStep else gamestep then
 again
;

: init     
  consmode off
  interpret hlp 
  mainloop
;

: FORTHERR
   ErrNo @ True =
   IfNot
      Base @ >r Decimal
      ." Error #" ErrNo @ . ."    "
      r> Base !
      ?Messages
      If
         ErrNo @ ErrorMessage .ASCIIz
      Then
   Then
   0 State !
   DropAll
   RDropAll
   mainloop
;

' ForthErr ErrorProc !

consmode off
0 lvl ! lvload

Restart init
Save soko-con.com

: main
  19 setvm
  begin
   show
   0 0 dxy!
   bkey
     328 ( up ) == if 0 -1 dxy! then
     333 ( right ) == if 1 0 dxy! then
     336 ( down )  == if 0 1 dxy! then
     331 ( left )  == if -1 0 dxy! then 
     43 == if lvl @ 1+ lvset then
     45 == if lvl @ 1- lvset then
     32 == if lvload then
     27 == if bye then
    rulez
    ?win if lvl 1+! lvload then
    dropall
  again
;

messages off debug on
' bye errorproc !
build soko.com

